----
-- upsidedown 7.11.2014

driveControl = {};
local driveControl_directory = g_currentModDirectory;




function driveControl:prerequisitesPresent(specializations)
    return true;
	--return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;



function driveControl:load(xmlFile)
	if g_currentMission.driveControl == nil then
		g_currentMission.driveControl = {};
		g_currentMission.driveControl.useModules = {};
		g_currentMission.driveControl.useModules.shuttle = true;		
		g_currentMission.driveControl.useModules.manMotorStart = true;
		g_currentMission.driveControl.useModules.gasGearLimiter = true;
		
		
		
		driveControl:loadConfigFile();
		
		--later load xml from userAppPath
	end;
	
	self.driveControl = {};
	self.driveControl.shuttle = {};
	self.driveControl.shuttle.direction = 1.0;
	self.driveControl.shuttle.onOffCnt = 0;
	self.driveControl.shuttle.isActive = true;
		
	self.driveControl.manMotorStart = {};
	self.driveControl.manMotorStart.isActive = true;
	self.driveControl.manMotorStart.isMotorStarted = false;
	self.driveControl.manMotorStart.startCnt = 0;
	
	self.driveControl.gasGearLimiter = {};
	self.driveControl.gasGearLimiter.gasLimiter = 1.0;
	self.driveControl.gasGearLimiter.gearLimiter = 1.0;
	
	local iconWidth = math.floor(0.0095*1920)/1920;
		
	self.overlayArrowUp = Overlay:new("overlayArrowUp", Utils.getFilename("arrowUp.dds", driveControl_directory), g_currentMission.speedHud.overlayValue1.x+.003,g_currentMission.speedHud.overlayValue1.y+0.076, iconWidth, iconWidth*16/9);
	self.overlayArrowDown = Overlay:new("overlayArrowDown", Utils.getFilename("arrowDown.dds", driveControl_directory), g_currentMission.speedHud.overlayValue1.x+.003,g_currentMission.speedHud.overlayValue1.y+0.076, iconWidth, iconWidth*16/9);
	
	self.overlayBattery = Overlay:new("overlayBattery", Utils.getFilename("battery.dds", driveControl_directory), g_currentMission.speedHud.overlayValue1.x+.037,g_currentMission.speedHud.overlayValue1.y+0.076, iconWidth, iconWidth*16/9);
	self.overlayPreHeat = Overlay:new("overlayPreHeat", Utils.getFilename("preHeat.dds", driveControl_directory), g_currentMission.speedHud.overlayValue1.x+.037,g_currentMission.speedHud.overlayValue1.y+0.076, iconWidth, iconWidth*16/9);
	
	
	self.overlayGears = Overlay:new("overlayGears", Utils.getFilename("gears.dds", driveControl_directory), g_currentMission.speedHud.overlayValue1.x+.037,g_currentMission.speedHud.overlayValue1.y+0.006, iconWidth, iconWidth*16/9);
	self.overlayPedals = Overlay:new("overlayPedals", Utils.getFilename("pedal.dds", driveControl_directory), g_currentMission.speedHud.overlayValue1.x+.003,g_currentMission.speedHud.overlayValue1.y+0.006, iconWidth, iconWidth*16/9);
	-- gears+pedal
	
end;


function driveControl:postLoad(xmlFile)
	if g_currentMission.driveControl.useModules.manMotorStart then
		self.stopMotorOnLeave = false;
	end;
	
	--self.motor.minForwardGearRatio = 5*self.motor.minForwardGearRatio;    -- <== this makes full rpm at low speed
	 
	if g_currentMission.driveControl.useModules.gasGearLimiter then
		self.driveControl.gasGearLimiter.originalMinForwardGearRatio = self.motor.minForwardGearRatio;
		self.driveControl.gasGearLimiter.originalMaxForwardGearRatio = self.motor.maxForwardGearRatio;
	
	end;
end;



function driveControl:motorStop(self,doStopSounds)	
	self.isMotorStarted = false;
	if Utils.getNoNil(doStopSounds,false) then
		-- self:stopMotor(g_server ~= nil);
		self:stopMotor(true);
	else
		Motorized.stopSounds(self);
		if self.exhaustParticleSystems ~= nil then
			Utils.setEmittingState(self.exhaustParticleSystems, false)
		end;
		
		if self.exhaustEffects~= nil then
			for _,effect in pairs(self.exhaustEffects) do
				setVisibility(effect.node,false);
			end;
		end;
	end;
	
	
	--print("motor turned off on enter")
end;


function driveControl:motorStart(self)
	-- self:startMotor(g_server == nil);
	self:startMotor(true);
	if self.exhaustParticleSystems ~= nil then
		Utils.setEmittingState(self.exhaustParticleSystems, true)
	end;
	
	if self.exhaustEffects~= nil then
		for _,effect in pairs(self.exhaustEffects) do
			setVisibility(effect.node,true);
		end;
	end;
end;

function driveControl:onEnter()
	if g_currentMission.driveControl.useModules.manMotorStart then
		if not self.driveControl.manMotorStart.isMotorStarted then
			driveControl:motorStop(self,false)
		end;
	end;
end;


function driveControl:mouseEvent(posX, posY, isDown, isUp, button)
end;

function driveControl:keyEvent(unicode, sym, modifier, isDown)
end;


function driveControl:updateTick(dt)
			
	if g_currentMission.driveControl.useModules.manMotorStart then
		if self.isHired then
			self.driveControl.manMotorStart.isMotorStarted = true;
		end;
		if self.driveControl.manMotorStart.isMotorStarted ~= self.isMotorStarted then
			if self.driveControl.manMotorStart.isMotorStarted then --turn on
				driveControl:motorStart(self)
			else --turn off
				driveControl:motorStop(self,true)
			end;		
		end;	
	end;
	
	if g_currentMission.driveControl.useModules.gasGearLimiter then
		if self.isServer then
			local overDrive = 2.0;
			
			local factor = 1/self.driveControl.gasGearLimiter.gearLimiter;
			
			local maxFac = self.driveControl.gasGearLimiter.originalMaxForwardGearRatio/self.driveControl.gasGearLimiter.originalMinForwardGearRatio;
			--print(maxFac)
			
			factor = Utils.clamp(factor,1.0,overDrive*maxFac);
			
			self.motor.minForwardGearRatio = factor * self.driveControl.gasGearLimiter.originalMinForwardGearRatio;
			if factor > maxFac then --we do gear overdrive
				self.motor.maxForwardGearRatio = self.motor.minForwardGearRatio;
				--print("overdrive")
			else
				self.motor.maxForwardGearRatio = self.driveControl.gasGearLimiter.originalMaxForwardGearRatio;
			end;
			
			--self.motor.minForwardGearRatio = self.driveControl.gasGearLimiter.originalMinForwardGearRatio;
			
			
		end;
	end;
	
	--self.driveControl.gasGearLimiter.gearLimiter
	
end;

function driveControl:update(dt)
	
	if self:getIsActiveForInput(false) or g_currentMission.controlledVehicle == self then 
	
		if g_currentMission.driveControl.useModules.manMotorStart then --manual motor start
			if self.driveControl.manMotorStart.isMotorStarted then
				if InputBinding.hasEvent(InputBinding.driveControlMotor) then --turn off
					self.driveControl.manMotorStart.isMotorStarted = false;
					driveControlInputEvent.sendEvent(self)
					--driveControl:motorStop(self,true)
				end;
				self.driveControl.manMotorStart.startCnt = 0;
			else
				if InputBinding.isPressed(InputBinding.driveControlMotor) then
					self.driveControl.manMotorStart.startCnt = self.driveControl.manMotorStart.startCnt + dt;
				else
					self.driveControl.manMotorStart.startCnt = 0;
				end;
				
				if self.driveControl.manMotorStart.startCnt > 800 then --turn on
					--print("start")
					--driveControl:motorStart(self)
					self.driveControl.manMotorStart.isMotorStarted = true;
					driveControlInputEvent.sendEvent(self)
				end;
			
			end;
		end;
		---------------------------------
		
		if g_currentMission.driveControl.useModules.gasGearLimiter then
			
			local change = 0.0002*dt;
			if InputBinding.isPressed(InputBinding.driveControlGearLimiterUp) then
				local oldValue = self.driveControl.gasGearLimiter.gearLimiter;
				self.driveControl.gasGearLimiter.gearLimiter = self.driveControl.gasGearLimiter.gearLimiter + change;
				self.driveControl.gasGearLimiter.gearLimiter = Utils.clamp(self.driveControl.gasGearLimiter.gearLimiter,0,1);
				if self.driveControl.gasGearLimiter.gearLimiter ~= oldValue then
					driveControlInputEvent.sendEvent(self);
					-- print("gear: ",self.driveControl.gasGearLimiter.gearLimiter*100)
				end;
			end;
			
			if InputBinding.isPressed(InputBinding.driveControlGearLimiterDown) then
				local oldValue = self.driveControl.gasGearLimiter.gearLimiter;
				self.driveControl.gasGearLimiter.gearLimiter = self.driveControl.gasGearLimiter.gearLimiter - change;
				self.driveControl.gasGearLimiter.gearLimiter = Utils.clamp(self.driveControl.gasGearLimiter.gearLimiter,0,1);
				if self.driveControl.gasGearLimiter.gearLimiter ~= oldValue then
					driveControlInputEvent.sendEvent(self);
					-- print("gear: ",self.driveControl.gasGearLimiter.gearLimiter*100)
				end;
			end;
			
			if InputBinding.isPressed(InputBinding.driveControlGasLimiterUp) then
				local oldValue = self.driveControl.gasGearLimiter.gasLimiter;
				self.driveControl.gasGearLimiter.gasLimiter = self.driveControl.gasGearLimiter.gasLimiter + change;
				self.driveControl.gasGearLimiter.gasLimiter = Utils.clamp(self.driveControl.gasGearLimiter.gasLimiter,0,1);
				if self.driveControl.gasGearLimiter.gasLimiter ~= oldValue then
					driveControlInputEvent.sendEvent(self);
					-- print("gas: ",self.driveControl.gasGearLimiter.gasLimiter*100)
				end;
			end;
			
			if InputBinding.isPressed(InputBinding.driveControlGasLimiterDown) then
				local oldValue = self.driveControl.gasGearLimiter.gasLimiter;
				self.driveControl.gasGearLimiter.gasLimiter = self.driveControl.gasGearLimiter.gasLimiter - change;
				self.driveControl.gasGearLimiter.gasLimiter = Utils.clamp(self.driveControl.gasGearLimiter.gasLimiter,0,1);
				if self.driveControl.gasGearLimiter.gasLimiter ~= oldValue then
					driveControlInputEvent.sendEvent(self);
					-- print("gas: ",self.driveControl.gasGearLimiter.gasLimiter*100)
				end;
			end;
			
		
		end;
	
		---------------------------------
		
		if g_currentMission.driveControl.useModules.shuttle then
			
			if InputBinding.isPressed(InputBinding.driveControlShuttle) then
				self.driveControl.shuttle.onOffCnt = self.driveControl.shuttle.onOffCnt + dt;
			else
				self.driveControl.shuttle.onOffCnt = 0;
			end;
			if self.driveControl.shuttle.onOffCnt > 2500 then
				self.driveControl.shuttle.isActive = not self.driveControl.shuttle.isActive;
				self.driveControl.shuttle.onOffCnt = -100000000000000000000000;
				--print("shuttle turned ",self.driveControl.shuttle.isActive)				
				driveControlInputEvent.sendEvent(self) 
			end;
			
			if self.driveControl.shuttle.isActive then
				if InputBinding.hasEvent(InputBinding.driveControlShuttle) then
					self.driveControl.shuttle.direction = -self.driveControl.shuttle.direction;					
					driveControlInputEvent.sendEvent(self)
				end;
			end;
		end;
				
	end;
end;


function driveControl:draw()
		
	if g_currentMission.driveControl.useModules.manMotorStart then
		if not self.driveControl.manMotorStart.isMotorStarted then
			if self.driveControl.manMotorStart.startCnt > 0 then
				self.overlayPreHeat:render();
			else
				self.overlayBattery:render();
			end;		
		end;
	end;
	
	if g_currentMission.driveControl.useModules.shuttle then
		if self.driveControl.shuttle.isActive then
			if self.driveControl.shuttle.direction > 0 then
				self.overlayArrowUp:render();
			else
				self.overlayArrowDown:render();
			end;
		end;
	end;
	
	if g_currentMission.driveControl.useModules.gasGearLimiter then
		self.overlayGears:render()
		self.overlayPedals:render()
		
		setTextBold(false);
		setTextAlignment(RenderText.ALIGN_CENTER);
		setTextColor(0.6307, 0.6307, 0.6307, 1);
		local str = tostring(math.floor(self.driveControl.gasGearLimiter.gasLimiter*100)).."%"
		renderText(g_currentMission.speedHud.overlayValue1.x+.009,g_currentMission.speedHud.overlayValue1.y,g_currentMission.speedUnitTextSize,str)
		
		str = tostring(math.floor(self.driveControl.gasGearLimiter.gearLimiter*100)).."%"
		renderText(g_currentMission.speedHud.overlayValue1.x+.04,g_currentMission.speedHud.overlayValue1.y,g_currentMission.speedUnitTextSize,str)
		setTextAlignment(RenderText.ALIGN_LEFT);
		setTextColor(1, 1, 1, 1);
	end;
			
end;


function driveControl:getSaveAttributesAndNodes(nodeIdent)
	local attributes = "";
	
	
	return attributes
end;


function driveControl:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		
	
	end;
	return BaseMission.VEHICLE_LOAD_OK;
end

function driveControl:writeStream(streamId, connection)
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.shuttle);
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.manMotorStart);
	streamWriteBool(streamId, g_currentMission.driveControl.useModules.gasGearLimiter);
	
	streamWriteBool(streamId, self.driveControl.shuttle.isActive);
	streamWriteFloat32(streamId, self.driveControl.shuttle.direction);
	streamWriteBool(streamId, self.driveControl.manMotorStart.isMotorStarted);
	streamWriteFloat32(streamId, self.driveControl.gasGearLimiter.gasLimiter);
	streamWriteFloat32(streamId, self.driveControl.gasGearLimiter.gearLimiter);
	
end;

function driveControl:readStream(streamId, connection) --sry, the server wins ;)
	g_currentMission.driveControl.useModules.shuttle = streamReadBool(streamId);
	g_currentMission.driveControl.useModules.manMotorStart = streamReadBool(streamId);
	g_currentMission.driveControl.useModules.gasGearLimiter = streamReadBool(streamId);
	
	local shuttleActive = streamReadBool(streamId);
	local shuttle = streamReadFloat32(streamId);
	local isMotorStarted = streamReadBool(streamId);
	local gasLimiter = streamReadFloat32(streamId);
	local gearLimiter = streamReadFloat32(streamId);
	
	self.driveControl.shuttle.isActive = shuttleActive;
	self.driveControl.shuttle.direction = shuttle;
	self.driveControl.manMotorStart.isMotorStarted = isMotorStarted;
	self.driveControl.gasGearLimiter.gasLimiter = gasLimiter;
	self.driveControl.gasGearLimiter.gearLimiter = gearLimiter;
end;

function driveControl:delete()	
end

function driveControl:loadConfigFile()
	local path = getUserProfileAppPath();
	local Xml;
	local file = path.."/driveControl_config.xml";
		
	if fileExists(file) then
		print("loading "..file.." for driveControl-Mod configuration");
		Xml = loadXMLFile("driveControl_XML", file, "driveControl");		
	else
		print("creating "..file.." for driveControl-Mod configuration");
		Xml = createXMLFile("driveControl_XML", file, "driveControl");
	end;
		
	local shuttle = getXMLBool(Xml, "driveControl.Modules.Shuttle");
	if shuttle ~= nil then
		g_currentMission.driveControl.useModules.shuttle = shuttle;
	else
		setXMLBool(Xml, "driveControl.Modules.Shuttle", true);
	end;
	
	local manMotorStart = getXMLBool(Xml, "driveControl.Modules.ManualMotorStart");
	if manMotorStart ~= nil then
		g_currentMission.driveControl.useModules.manMotorStart = manMotorStart;
	else
		setXMLBool(Xml, "driveControl.Modules.ManualMotorStart", true);
	end;

	local gasGear = getXMLBool(Xml, "driveControl.Modules.GasAndGearLimiter");
	if gasGear ~= nil then
		g_currentMission.driveControl.useModules.gasGearLimiter = gasGear;
	else
		setXMLBool(Xml, "driveControl.Modules.GasAndGearLimiter", true);
	end;	
		
	saveXMLFile(Xml);
end;



if Drivable.driveControlInstalled == nil then
	print("--- installing driveControl by upsidedown into Drivable and Steerable...")
	local oldFunc = Drivable.updateVehiclePhysics;
	function Drivable.updateVehiclePhysics(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, dt)
				
		if g_currentMission.driveControl.useModules.shuttle and self.driveControl.shuttle.isActive then
			
			--print(self.movingDirection," ",self.driveControl.shuttle.direction," ",self.vehicleMovingDirection)
			
			if self.driveControl.shuttle.direction < 0 then
				axisForward = -axisForward;
			end;
			
			if self.movingDirection ~= self.driveControl.shuttle.direction then
				if self.driveControl.shuttle.direction < 0 then
					axisForward = Utils.clamp(axisForward,0,1);			
				else
					axisForward = Utils.clamp(axisForward,-1,0);			
				end;
			end;
			
			-- if self.movingDirection == 0 then
				-- axisForward = Utils.clamp(axisForward,-1,0);
			-- end;
			
			self.GPSmovingDirection = self.driveControl.shuttle.direction;
			self.GPSmovingDirectionCnt = 40; --here we remotely handle direction mechanics from GPS. no problem if GPS is not installed
			
		end;
		
		
		if g_currentMission.driveControl.useModules.gasGearLimiter then
			--self.driveControl.gasGearLimiter.gasLimiter
			if self.driveControl.gasGearLimiter.gasLimiter < 1.0 then
				local axisFactor = self.driveControl.gasGearLimiter.gasLimiter;
				
				local maxSpeed = Utils.getNoNil(self.cruiseControl.maxSpeed,40)*self.driveControl.gasGearLimiter.gasLimiter
				local alpha = (maxSpeed - self.lastSpeed*3600)/maxSpeed;
				alpha = Utils.clamp(alpha,0,1);
				--print(alpha)
				axisFactor = alpha*axisFactor;
				-- local directionAxis = axisForward;
				-- if g_currentMission.driveControl.useModules.shuttle and self.driveControl.shuttle.isActive and self.driveControl.shuttle.direction < 0 then
					-- directionAxis = -directionAxis;
				-- end;
				
				-- if directionAxis < 0 then
					axisForward = axisForward*axisFactor; 
					axisForwardIsAnalog = true; 
				-- end;
			end;
		end;
		
		
		oldFunc(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, dt)
	end;

	
	
	local oldFunc2 = Steerable.update;
	function Steerable.update(self,dt)
		if g_currentMission.controlledVehicle == self then
			if g_currentMission.driveControl.useModules.gasGearLimiter then
				if InputBinding.isPressed(InputBinding.driveControlGasLimiterUp) then
					InputBinding.actions[InputBinding.AXIS_LOOK_UPDOWN_VEHICLE].lastInputAxis = 0;
				end;
				
				if InputBinding.isPressed(InputBinding.driveControlGasLimiterDown) then
					InputBinding.actions[InputBinding.AXIS_LOOK_UPDOWN_VEHICLE].lastInputAxis = 0;
				end;
				
				if InputBinding.isPressed(InputBinding.driveControlGearLimiterUp) then
					InputBinding.actions[InputBinding.AXIS_LOOK_LEFTRIGHT_VEHICLE].lastInputAxis = 0;
				end;
				
				if InputBinding.isPressed(InputBinding.driveControlGearLimiterDown) then
					InputBinding.actions[InputBinding.AXIS_LOOK_LEFTRIGHT_VEHICLE].lastInputAxis = 0;
				end;
			end;
		end;
		
		oldFunc2(self,dt);
	end;
	
	
	
	----
	
	

	Drivable.driveControlInstalled = true;
end;





driveControlInputEvent = {};
driveControlInputEvent_mt = Class(driveControlInputEvent, Event);

InitEventClass(driveControlInputEvent, "driveControlInputEvent");

function driveControlInputEvent:emptyNew()
    local self = Event:new(driveControlInputEvent_mt);
    self.className="driveControlInputEvent";
    return self;
end;

function driveControlInputEvent:new(vehicle)
    local self = driveControlInputEvent:emptyNew()
    self.vehicle = vehicle;
	self.shuttleActive = vehicle.driveControl.shuttle.isActive
	self.shuttle = vehicle.driveControl.shuttle.direction;
	self.isMotorStarted = vehicle.driveControl.manMotorStart.isMotorStarted;
	self.gasLimiter = vehicle.driveControl.gasGearLimiter.gasLimiter;
	self.gearLimiter = vehicle.driveControl.gasGearLimiter.gearLimiter;
	-- print("event new")
    return self;
end;

function driveControlInputEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.shuttleActive);
	streamWriteFloat32(streamId, self.shuttle);
	streamWriteBool(streamId, self.isMotorStarted);
	streamWriteFloat32(streamId, self.gasLimiter);
	streamWriteFloat32(streamId, self.gearLimiter);
	-- print("event writeStream")
end;

function driveControlInputEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    local vehicle = networkGetObject(id);
	
	local shuttleActive = streamReadBool(streamId);
	local shuttle = streamReadFloat32(streamId);
	local isMotorStarted = streamReadBool(streamId);
	local gasLimiter = streamReadFloat32(streamId);
	local gearLimiter = streamReadFloat32(streamId);
	
	vehicle.driveControl.shuttle.isActive = shuttleActive;
	vehicle.driveControl.shuttle.direction = shuttle;
	vehicle.driveControl.manMotorStart.isMotorStarted = isMotorStarted;
	vehicle.driveControl.gasGearLimiter.gasLimiter = gasLimiter;
	vehicle.driveControl.gasGearLimiter.gearLimiter = gearLimiter;
	-- print("event readStream")
	-- print(shuttleActive,shuttle,isMotorStarted,gasLimiter,gearLimiter)
	if g_server ~= nil then	
		g_server:broadcastEvent(driveControlInputEvent:new(vehicle), nil, nil, vehicle);
		-- print("broadcasting")
	end;
end;

function driveControlInputEvent.sendEvent(vehicle)
	if g_server ~= nil then	
		--g_server:broadcastEvent(driveControlInputEvent:new(vehicle), nil, nil, self);
		-- print("broadcasting")
	else
		g_client:getServerConnection():sendEvent(driveControlInputEvent:new(vehicle));
		-- print("sending event to server...")
	end;
end;